openerp.eiru_import_statement = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.VoucherImportWidget = instance.Widget.extend({
        template: 'EiruImport.Statement',
        id: undefined,
        bankStatement: [],

        init: function (parent) {
            this._super(parent);
        },
        // Actualizar id del Objeto
        updateId: function(id) {
            var self = this;
            self.id = id;
        },
        start: function() {
            var self = this;
            this.$el.click(function() {
                self.fetchInitial();
            });
        },
        /* Iniciar */
        fetchInitial: function() {
            var self = this;

            self.$el.attr("disabled", true);

            self.fetchBankStatement(self.id).then(function(bankStatement) {
                return bankStatement;
            }).then(function(bankStatement) {
                self.bankStatement = bankStatement;
                if (!!self.bankStatement.length && !!self.bankStatement[0].pos_session_id){
                    instance.web.notification.do_notify("Atención","Esta opción solo esta disponible para la caja general.");
                    return false;
                }
                return self.fetchStatementPointOfSale(self.id).then(function(statementPoinOfSale){
                    return statementPoinOfSale;
                }).then(function(statementPoinOfSale){
                    self.statementPoinOfSale = statementPoinOfSale;
                });
            }).then(function() {
                local.parentInstance.reload();
                self.$el.removeAttr("disabled");
            });
        },
        /* Registro de Caja */
        fetchBankStatement: function(id) {
            var fields = ['id', 'journal_id', 'pos_session_id', 'date'];
            var domain = [['id', '=', id]];
            var statement = new instance.web.Model('account.bank.statement');
            return statement.query(fields).filter(domain).all();
        },
        /* Get Statement Point of Sale*/
        fetchStatementPointOfSale: function(id){
            var invoiceMoveLine = new instance.web.Model('account.bank.statement');
            return invoiceMoveLine.call('get_statement_point_of_sale',[id], {
                context: new instance.web.CompoundContext()
            });
        }
    });

    if (instance.web && instance.web.FormView) {
        instance.web.FormView.include({
            load_record: function (record) {
                this._super.apply(this, arguments);

                if (this.model !== 'account.bank.statement') return;

                local.parentInstance = this;

                if (local.widgetInstance)
                    local.widgetInstance.updateId(record.id);

                if (this.$el.find('.button-import-statement').length !== 0) return;

                local.widgetInstance = new local.VoucherImportWidget(this);
                var element = this.$el.find('.oe_form').find('.import-statement');

                local.widgetInstance.appendTo(element);
                local.widgetInstance.updateId(record.id);
            }
        });
    }

}
